
#ifndef _SIGNALUTIL_H_
#define _SIGNALUTIL_H_

/**
  A collection of utility functions for signal generation
  and signal code debug.
 */
class signalUtil {
private:
  /// This class is designed to provide static functions, not
  /// to be declared as a class instance.
  signalUtil() {};
  ~signalUtil() {};
  signalUtil(const signalUtil &rhs ) {}

public:
  static void gen_freqMix( double *vecX, double *vecY, size_t N);

  static void gen_sinCombo( double *vecX, double *vecY, size_t N );

  static void prCoords( double *vecX, double *vecY, size_t len );

  static void prVec( double *vec, size_t len );

  static bool vecEqual( const double *d1,
			const double *d2,
			const size_t N );

  static double new_y( size_t x1, double y1, 
		       size_t x2, double y2,
		       size_t newX );

  static void sawToothWave( double *vec,
			    size_t N,
			    size_t numCycles,
			    double amplitude );
  static void addSignal( double *C, 
			 const double *A,
			 const double *B,
			 const size_t N );
}; // signalUtil

#endif
