
#include "waveletDebug.h"
#include "polyHaar.h"

/** \file
  Test for polynomial interpolation wavelets
 */

double data[] = { 32.0, 10.0, 20.0, 38.0, 37.0, 28.0, 38.0, 34.0,
                  18.0, 24.0, 18.0, 9.0, 23.0, 24.0, 28.0, 34.0 };



/**
  Compare two integer arrays of size N.  Return true if they are
  equal, false otherwise.
 */
bool compare( const double *v1, const double *v2, const size_t N )
{
  bool rslt = true;

  for (size_t i = 0; i < N; i++) 
  {
    if (v1[i] != v2[i])
    {
      rslt = false;
      break;
    }
  }

  return rslt;
} // compare


/**

  Make a copy of an integer array.  Note that the function
  allocates memory, but does not deallocate it.
 */
double *copy( double *vec, const size_t N )
{
  double *newVec = new double[ N ];

  for (size_t i = 0; i < N; i++)
  {
    newVec[i] = vec[i];
  }

  return newVec;
} // copy


main()
{
  waveletDebug d;
  polyHaar<double *> w;

  size_t N = sizeof( data) / sizeof(double);

  double *copyVec = copy( data, N );

  double *ptr = data;
  w.forwardTrans( ptr, N );
  d.pr_ordered( data, N );

  w.inverseTrans( ptr, N );

  if (compare(data, copyVec, N))
    printf("inverse transform succeeded\n");
  else
    printf("inverse transform failed\n");

  return 0;
}
